#!/bin/bash
##################################################
## Tutorial Case 1 - ToDo/TASK:                 ##
## Complete script template for bwUniCluster    ##
## to run jobs on tmpdir                        ##
## * Write code for sections a,c,d,e,f,h        ##    
## * Generalise code avoiding repetition        ##
## * Redirect output of binary                  ##
##################################################
## ver.  : 2016-12-06, Robert Barthel, KIT, SCC
##
## Syntax:
##   ^                         = begin of line
##   <int>                     = integer placeholder
##   ^##                       = comment
##
## How define MOAB resources in file:   
##   ^#MSUB -l nodes=<int>:ppn=<int> = defines nodes and cores per node
##   ^#MSUB -l walltime=hh:mm:ss     = defines walltime in hh:mm:ss
##   ^#MSUB -N <jobname>             = defines jobname
##   ^#MSUB -m <email_option>        = defines nofication condition
##
## Note: 
##   - all '#MSUB -?' are equivalent to 'msub -?'
##   - for more options, see 'man msub'
##   - '# MSUB' is a comment, while '#MSUB' is a msub option statement

##################################################
## HEADER: Define here your Compute resources   ##
##################################################
#MSUB -N test
#MSUB -l advres=workshop.8,nodes=1:ppn=1,mem=50mb
#MSUB -l walltime=00:05:00
#MSUB -m n


##################################################
## Declarations: setup environment etc.         ##
##################################################
## Generalised code parts
## 1) Tutorial ToDo: Define full path of your binary
EXE=

## 2) Tutorial ToDo: Define output file 
##    = Name of executable + JOBID or PID 
output=

## 3) Tutorial ToDo: Define input files 
input=

## 4) Tutorial ToDo: Define input files to be copied
copy_list=

## 5) Tutorial ToDo: Define files to be copied back after run, i.e. output file
save_list=

##################################################
## BODY:                                        ##
##################################################
## a) Tutorial ToDo: load modules INTEL+MKL if not loaded

## b) Define your run directory under tmpdir incorporating username and JobID or PID
##    and generate via mkdir
mkdir -pv "${TMP}/${USER}.${MOAB_JOBID:-$$}"
 
## c) Tutorial ToDo: Check existence of run directory

## d) Copy program and input from submit directory
##    to run directory 
cd "${MOAB_SUBMITDIR:-${PWD}}"
cp -pv gen_files.x   "${TMP}/${USER}.${MOAB_JOBID:-$$}"
##    Tutorial ToDo: Check if copy succeeded
cp -pv gen_files.inp "${TMP}/${USER}.${MOAB_JOBID:-$$}"

## e) Change to run directory and start "binary" together with input file
cd "${TMP}/${USER}.${MOAB_JOBID:-$$}"
##    Tutorial ToDo: Check if change to directory succeeded
./01_gen_files.x 01_gen_files.inp

##################################################
## FOOTER: check job, cleanup your job etc.     ##
##################################################
## f) Tutorial ToDo: Check run status

## g) Transfer output files to submit directory
cp -pv files_*.out "${MOAB_SUBMITDIR}"

## h) Tutorial ToDo: Cleanup run_DIR

exit 0
